'use strict';

exports.__esModule = true;
exports['default'] = transducerProtocol;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _constants = require('./constants');

var Store = (function () {
  function Store(store) {
    _classCallCheck(this, Store);

    this.store = store;
    Object.assign(this, store);
  }

  Store.prototype[_constants.INIT] = function () {
    return this.store;
  };

  Store.prototype[_constants.STEP] = function (store, action) {
    store.dispatch(action);
    return store;
  };

  Store.prototype[_constants.RESULT] = function (store) {
    return store;
  };

  return Store;
})();

function transducerProtocol(next) {
  return function () {
    return new Store(next.apply(undefined, arguments));
  };
}

module.exports = exports['default'];